package main

import (
	"fmt"
	"io"
	"os"
)

// ExampleFilePoint
func main() {
	path := "/etc/hosts"
	//path := "a.txt"

	// 打开文件
	file, err := os.Open(path)
	// 结束时关闭文件
	defer file.Close()
	if err != nil {
		fmt.Println(err.Error())
		return
	} else {
		// 读文件
		fmt.Printf("%T\n", file)

		// 移动文件指针
		// offset 偏移量
		// whence 相对位置
		//  0 means relative to the origin of the file, os.SEEK_SET
		//  1 means relative to the current offset, os.SEEK_CUR
		//  2 means relative to the end, os.SEEK_END
		ret, err := file.Seek(0, 2)
		if err != nil {
			return
		}
		fmt.Println("current ", ret)

		var bs []byte = make([]byte, 10) // [0 0 0 0 0 0 0 0 0 0]
		for {
			n, err := file.Read(bs)
			if err == io.EOF || err != nil {
				if err == io.EOF {
					fmt.Println(err.Error())
				}
				break
			}
			fmt.Print(string(bs[:n]))
		}
	}
}
